import os
import shutil
import paramiko

LOCAL_DIR = './target'
REMOTE_DIR = '/opt/jars'

mindaEnable = True
wanqiEnable = False

# SSH连接信息
MINDA_HOST = '111.56.16.62'
WANQI_HOST = '39.153.214.14'
MINDA_PORT = 198
WANQI_PORT = 31
MINDA_USERNAME = 'root'
MINDA_PASSWORD = 'gnkj,bn@01'
WANQI_USERNAME = 'root'
WANQI_PASSWORD = 'gnkj,bn@01'

for filename in os.listdir(LOCAL_DIR):
    if filename.startswith('flink'):
        name_parts = filename.split('-')
        module1 = name_parts[1]
        module2 = name_parts[2]
        # 去掉.jar后缀
        version = name_parts[3][:-4]

        print(f'find jar file {filename} with version {version} in module {module1}/{module2}')

        remote_path = f'{REMOTE_DIR}/{module1}/{module2}/{version}/{filename}'
        remote_config_path = f'{REMOTE_DIR}/{module1}/{module2}/{version}/config.json'
        local_path = f'{LOCAL_DIR}/{filename}'

        # 检查父目录是否存在,不存在则创建
        remote_parent_dir = os.path.dirname(remote_path)

        if mindaEnable:
            mindaClient = paramiko.SSHClient()
            mindaClient.set_missing_host_key_policy(paramiko.AutoAddPolicy())
            mindaClient.connect(MINDA_HOST, port=MINDA_PORT, username=MINDA_USERNAME, password=MINDA_PASSWORD)
            minda_sftp = mindaClient.open_sftp()

            try:
                print(f'check minda parent directory {remote_parent_dir}')
                minda_sftp.stat(remote_parent_dir)
            except IOError:
                print(f'minda Remote parent dir {remote_parent_dir} not exists, creating it first...')
                minda_sftp.mkdir(remote_parent_dir)

            print(f'Uploading minda jar file {local_path} to {remote_path}')
            minda_sftp.put(local_path, remote_path)
            minda_config_path = f'./config/minda-config.json'
            print(f'Uploading minda config file {minda_config_path} to {remote_config_path}')
            minda_sftp.put(minda_config_path, remote_config_path)

            minda_sftp.close()
            mindaClient.close()

        if wanqiEnable:
            wanqiClient = paramiko.SSHClient()
            wanqiClient.set_missing_host_key_policy(paramiko.AutoAddPolicy())
            wanqiClient.connect(WANQI_HOST, port=WANQI_PORT, username=WANQI_USERNAME, password=WANQI_PASSWORD)
            wanqi_sftp = wanqiClient.open_sftp()

            try:
                print(f'check wanqi parent directory {remote_parent_dir}')
                wanqi_sftp.stat(remote_parent_dir)
            except IOError:
                print(f'wanqi Remote parent dir {remote_parent_dir} not exists, creating it first...')
                wanqi_sftp.mkdir(remote_parent_dir)

            print(f'Uploading wanqi jar file {local_path} to {remote_path}')
            wanqi_sftp.put(local_path, remote_path)
            wanqi_config_path = f'./config/wanqi-config.json'
            print(f'Uploading minda config file {wanqi_config_path} to {remote_config_path}')
            wanqi_sftp.put(wanqi_config_path, remote_config_path)

            wanqi_sftp.close()
            wanqiClient.close()

print('Upload complete!')
