import paramiko
import os
from sftp import SFTPClient
from threading import Thread

SERVERS = {
    'minda': {
        'host': '111.56.16.62',
        'port': 198,
        'username': 'root',
        'password': 'gnkj,bn@01'
    },
    'wanqi': {
        'host': '39.153.214.14',
        'port': 31,
        'username': 'root',
        'password': 'gnkj,bn@01'
    }
}

TARGET_DIR = '/opt/jars'


class SSHClient:

    def __init__(self, config):
        self.config = config
        self.client = None

    def connect(self):
        self.client = paramiko.SSHClient()
        self.client.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        self.client.connect(
            self.config['host'],
            port=self.config['port'],
            username=self.config['username'],
            password=self.config['password']
        )

    def close(self):
        if self.client:
            self.client.close()

    def upload_file(self, local_path, remote_path):
        try:
            sftp = SFTPClient(self.client)
            parent_dir = os.path.dirname(remote_path)
            if not sftp.exists(parent_dir):
                sftp.mkdir(parent_dir)
            sftp.put(local_path, remote_path)
            print(f'Uploaded {local_path} to {remote_path}')
        except Exception as e:
            print(f'Upload failed: {e}')


def upload_file(ssh_client, file_info):
    local_path = file_info['local']
    remote_path = f'{TARGET_DIR}/{file_info["module"]}/{file_info["version"]}/{file_info["name"]}'
    ssh_client.upload_file(local_path, remote_path)


# 遍历本地目录,上传文件
for filename in os.listdir('./jars'):
    name, extension = os.path.splitext(filename)
    if extension == '.jar':
        module, version = name.split('-')
        file_info = {
            'name': filename,
            'local': f'./jars/{filename}',
            'module': module,
            'version': version
        }

        # 多线程上传
        threads = []
        for name, config in SERVERS.items():
            ssh_client = SSHClient(config)
            t = Thread(target=upload_file, args=(ssh_client, file_info))
            threads.append(t)

        for t in threads:
            t.start()

        for t in threads:
            t.join()

print('all files uploaded')
