#!/bin/bash

VERSION=$1
FLINK_HOME=/opt/flink-1.16.0
SERVER_NAME=wanqi

if [ -z "$VERSION" ]; then
  echo "Usage: $0 <version>"
  exit 1
fi

$FLINK_HOME/bin/flink run-application -t yarn-application \
  -Dyarn.application.name="${SERVER_NAME} kafa -> mqtt v${VERSION}" \
  -Dtaskmanager.numberOfTaskSlots=3 -Dyarn.containers.vcores=3 \
  /opt/jars/kafka/mqtt/"${VERSION}"/flink-kafka-mqtt-"${VERSION}".jar \
  /opt/jars/kafka/mqtt/"${VERSION}"/config.json